//
//  MedtechAnalysis.cc
//  medtech
//
//  Created by Baranyai David on 2018. 04. 03..
//

#include "MedtechAnalysis.hh"

MedtechAnalysis::MedtechAnalysis()
{
    char filename[20];
    Parameters *parameter = Parameters::getInstance();
    snprintf(filename, 30, "data_c%dt%d.root", (int)parameter -> GetConeSize(), (int)parameter -> GetTubeSize());
    tree = new TTree("tree", "tree");
    file = new TFile(filename,"RECREATE");
    instance = this;
    MedtechAnalysisMutex = G4MUTEX_INITIALIZER;
    
    tree -> Branch("x", &x, "x/D");
    tree -> Branch("y", &y, "y/D");
    tree -> Branch("e", &e, "e/D");
}

MedtechAnalysis::~MedtechAnalysis()
{
    
}

MedtechAnalysis* MedtechAnalysis::getInstance()
{
    if (instance == 0)
    {
        std::cout << "Created instance" << std::endl;
        instance = new MedtechAnalysis();
    }
    
    return instance;
}

void MedtechAnalysis::Fill(double x1, double y1, double e1)
{
    G4AutoLock lock(&MedtechAnalysisMutex);
    
    x = x1;
    y = y1;
    e = e1;
    
    tree -> Fill();
    
    lock.unlock();
}

void MedtechAnalysis::Close()
{
    tree -> Write();
    file -> Close();
}

/* Null, because instance will be initialized on demand. */
MedtechAnalysis* MedtechAnalysis::instance = 0;
